/* valainitializerlist.c generated by valac, the Vala compiler
 * generated from valainitializerlist.vala, do not modify */

/* valainitializerlist.vala
 *
 * Copyright (C) 2006-2011  Jürg Billeter
 * Copyright (C) 2006-2008  Raffaele Sandrini
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 * 	Raffaele Sandrini <raffaele@sandrini.ch>
 */

#include "vala.h"
#include <valagee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_iterator_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterator_unref (var), NULL)))

struct _ValaInitializerListPrivate {
	ValaList* initializers;
};

static gint ValaInitializerList_private_offset;
static gpointer vala_initializer_list_parent_class = NULL;

static void vala_initializer_list_real_accept_children (ValaCodeNode* base,
                                                 ValaCodeVisitor* visitor);
static void vala_initializer_list_real_accept (ValaCodeNode* base,
                                        ValaCodeVisitor* visitor);
static gboolean vala_initializer_list_real_is_constant (ValaExpression* base);
static gboolean vala_initializer_list_real_is_pure (ValaExpression* base);
static gboolean vala_initializer_list_real_is_accessible (ValaExpression* base,
                                                   ValaSymbol* sym);
static gchar* vala_initializer_list_real_to_string (ValaCodeNode* base);
static void vala_initializer_list_real_replace_expression (ValaCodeNode* base,
                                                    ValaExpression* old_node,
                                                    ValaExpression* new_node);
static gboolean vala_initializer_list_real_check (ValaCodeNode* base,
                                           ValaCodeContext* context);
static void vala_initializer_list_real_emit (ValaCodeNode* base,
                                      ValaCodeGenerator* codegen);
static void vala_initializer_list_real_get_used_variables (ValaCodeNode* base,
                                                    ValaCollection* collection);
static void vala_initializer_list_finalize (ValaCodeNode * obj);
static GType vala_initializer_list_get_type_once (void);

static inline gpointer
vala_initializer_list_get_instance_private (ValaInitializerList* self)
{
	return G_STRUCT_MEMBER_P (self, ValaInitializerList_private_offset);
}

/**
 * Appends the specified expression to this initializer
 *
 * @param expr an expression
 */
void
vala_initializer_list_append (ValaInitializerList* self,
                              ValaExpression* expr)
{
	ValaList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->initializers;
	vala_collection_add ((ValaCollection*) _tmp0_, expr);
	vala_code_node_set_parent_node ((ValaCodeNode*) expr, (ValaCodeNode*) self);
}

/**
 * Returns the initalizer expression list
 *
 * @return expression list
 */
ValaList*
vala_initializer_list_get_initializers (ValaInitializerList* self)
{
	ValaList* _tmp0_;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->initializers;
	result = _tmp0_;
	return result;
}

gint
vala_initializer_list_get_size (ValaInitializerList* self)
{
	gint result;
	ValaList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->initializers;
	_tmp1_ = vala_collection_get_size ((ValaCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

/**
 * Creates a new initializer
 *
 * @param source_reference reference to source code
 * @return                 newly created initializer list
 */
ValaInitializerList*
vala_initializer_list_construct (GType object_type,
                                 ValaSourceReference* source_reference)
{
	ValaInitializerList* self = NULL;
	g_return_val_if_fail (source_reference != NULL, NULL);
	self = (ValaInitializerList*) vala_expression_construct (object_type);
	vala_code_node_set_source_reference ((ValaCodeNode*) self, source_reference);
	return self;
}

ValaInitializerList*
vala_initializer_list_new (ValaSourceReference* source_reference)
{
	return vala_initializer_list_construct (VALA_TYPE_INITIALIZER_LIST, source_reference);
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static void
vala_initializer_list_real_accept_children (ValaCodeNode* base,
                                            ValaCodeVisitor* visitor)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (visitor != NULL);
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _expr_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _expr_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_expr_list = _tmp1_;
		_tmp2_ = _expr_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_expr_size = _tmp4_;
		_expr_index = -1;
		while (TRUE) {
			ValaExpression* expr = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_expr_index = _expr_index + 1;
			if (!(_expr_index < _expr_size)) {
				break;
			}
			_tmp5_ = _expr_list;
			_tmp6_ = vala_list_get (_tmp5_, _expr_index);
			expr = (ValaExpression*) _tmp6_;
			_tmp7_ = expr;
			vala_code_node_accept ((ValaCodeNode*) _tmp7_, visitor);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
}

static void
vala_initializer_list_real_accept (ValaCodeNode* base,
                                   ValaCodeVisitor* visitor)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_initializer_list (visitor, self);
	vala_code_visitor_visit_expression (visitor, (ValaExpression*) self);
}

static gboolean
vala_initializer_list_real_is_constant (ValaExpression* base)
{
	ValaInitializerList * self;
	gboolean result = FALSE;
	self = (ValaInitializerList*) base;
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _initializer_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _initializer_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_initializer_list = _tmp1_;
		_tmp2_ = _initializer_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_initializer_size = _tmp4_;
		_initializer_index = -1;
		while (TRUE) {
			ValaExpression* initializer = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_initializer_index = _initializer_index + 1;
			if (!(_initializer_index < _initializer_size)) {
				break;
			}
			_tmp5_ = _initializer_list;
			_tmp6_ = vala_list_get (_tmp5_, _initializer_index);
			initializer = (ValaExpression*) _tmp6_;
			_tmp7_ = initializer;
			if (!vala_expression_is_constant (_tmp7_)) {
				result = FALSE;
				_vala_code_node_unref0 (initializer);
				_vala_iterable_unref0 (_initializer_list);
				return result;
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	result = TRUE;
	return result;
}

static gboolean
vala_initializer_list_real_is_pure (ValaExpression* base)
{
	ValaInitializerList * self;
	gboolean result = FALSE;
	self = (ValaInitializerList*) base;
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _initializer_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _initializer_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_initializer_list = _tmp1_;
		_tmp2_ = _initializer_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_initializer_size = _tmp4_;
		_initializer_index = -1;
		while (TRUE) {
			ValaExpression* initializer = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_initializer_index = _initializer_index + 1;
			if (!(_initializer_index < _initializer_size)) {
				break;
			}
			_tmp5_ = _initializer_list;
			_tmp6_ = vala_list_get (_tmp5_, _initializer_index);
			initializer = (ValaExpression*) _tmp6_;
			_tmp7_ = initializer;
			if (!vala_expression_is_pure (_tmp7_)) {
				result = FALSE;
				_vala_code_node_unref0 (initializer);
				_vala_iterable_unref0 (_initializer_list);
				return result;
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	result = TRUE;
	return result;
}

static gboolean
vala_initializer_list_real_is_accessible (ValaExpression* base,
                                          ValaSymbol* sym)
{
	ValaInitializerList * self;
	gboolean result = FALSE;
	self = (ValaInitializerList*) base;
	g_return_val_if_fail (sym != NULL, FALSE);
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _initializer_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _initializer_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_initializer_list = _tmp1_;
		_tmp2_ = _initializer_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_initializer_size = _tmp4_;
		_initializer_index = -1;
		while (TRUE) {
			ValaExpression* initializer = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_initializer_index = _initializer_index + 1;
			if (!(_initializer_index < _initializer_size)) {
				break;
			}
			_tmp5_ = _initializer_list;
			_tmp6_ = vala_list_get (_tmp5_, _initializer_index);
			initializer = (ValaExpression*) _tmp6_;
			_tmp7_ = initializer;
			if (!vala_expression_is_accessible (_tmp7_, sym)) {
				result = FALSE;
				_vala_code_node_unref0 (initializer);
				_vala_iterable_unref0 (_initializer_list);
				return result;
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	result = TRUE;
	return result;
}

static gchar*
vala_initializer_list_real_to_string (ValaCodeNode* base)
{
	ValaInitializerList * self;
	GString* builder = NULL;
	GString* _tmp0_;
	gboolean first = FALSE;
	GString* _tmp16_;
	GString* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* result = NULL;
	self = (ValaInitializerList*) base;
	_tmp0_ = g_string_new ("{");
	builder = _tmp0_;
	first = TRUE;
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp1_;
		ValaList* _tmp2_;
		gint _initializer_size = 0;
		ValaList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _initializer_index = 0;
		_tmp1_ = self->priv->initializers;
		_tmp2_ = _vala_iterable_ref0 (_tmp1_);
		_initializer_list = _tmp2_;
		_tmp3_ = _initializer_list;
		_tmp4_ = vala_collection_get_size ((ValaCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_initializer_size = _tmp5_;
		_initializer_index = -1;
		while (TRUE) {
			ValaExpression* initializer = NULL;
			ValaList* _tmp6_;
			gpointer _tmp7_;
			_initializer_index = _initializer_index + 1;
			if (!(_initializer_index < _initializer_size)) {
				break;
			}
			_tmp6_ = _initializer_list;
			_tmp7_ = vala_list_get (_tmp6_, _initializer_index);
			initializer = (ValaExpression*) _tmp7_;
			if (first) {
				GString* _tmp8_;
				ValaExpression* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				_tmp8_ = builder;
				_tmp9_ = initializer;
				_tmp10_ = vala_code_node_to_string ((ValaCodeNode*) _tmp9_);
				_tmp11_ = _tmp10_;
				g_string_append (_tmp8_, _tmp11_);
				_g_free0 (_tmp11_);
				first = FALSE;
			} else {
				GString* _tmp12_;
				ValaExpression* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				_tmp12_ = builder;
				_tmp13_ = initializer;
				_tmp14_ = vala_code_node_to_string ((ValaCodeNode*) _tmp13_);
				_tmp15_ = _tmp14_;
				g_string_append_printf (_tmp12_, ", %s", _tmp15_);
				_g_free0 (_tmp15_);
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	_tmp16_ = builder;
	g_string_append_c (_tmp16_, '}');
	_tmp17_ = builder;
	_tmp18_ = _tmp17_->str;
	_tmp19_ = g_strdup (_tmp18_);
	result = _tmp19_;
	_g_string_free0 (builder);
	return result;
}

static void
vala_initializer_list_real_replace_expression (ValaCodeNode* base,
                                               ValaExpression* old_node,
                                               ValaExpression* new_node)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				ValaList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				ValaList* _tmp5_;
				gpointer _tmp6_;
				ValaExpression* _tmp7_;
				gboolean _tmp8_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->initializers;
				_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
				_tmp4_ = _tmp3_;
				if (!(i < _tmp4_)) {
					break;
				}
				_tmp5_ = self->priv->initializers;
				_tmp6_ = vala_list_get (_tmp5_, i);
				_tmp7_ = (ValaExpression*) _tmp6_;
				_tmp8_ = _tmp7_ == old_node;
				_vala_code_node_unref0 (_tmp7_);
				if (_tmp8_) {
					ValaList* _tmp9_;
					_tmp9_ = self->priv->initializers;
					vala_list_set (_tmp9_, i, new_node);
					vala_code_node_set_parent_node ((ValaCodeNode*) new_node, (ValaCodeNode*) self);
				}
			}
		}
	}
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

static gboolean
vala_initializer_list_real_check (ValaCodeNode* base,
                                  ValaCodeContext* context)
{
	ValaInitializerList * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaDataType* _tmp4_;
	ValaDataType* _tmp5_;
	gboolean _error_ = FALSE;
	ValaDataType* _tmp245_;
	ValaDataType* _tmp246_;
	gboolean result = FALSE;
	self = (ValaInitializerList*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_expression_get_target_type ((ValaExpression*) self);
	_tmp5_ = _tmp4_;
	if (_tmp5_ == NULL) {
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp6_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp7_ = _tmp6_;
		vala_report_error (_tmp7_, "initializer list used for unknown type");
		result = FALSE;
		return result;
	} else {
		ValaDataType* _tmp8_;
		ValaDataType* _tmp9_;
		_tmp8_ = vala_expression_get_target_type ((ValaExpression*) self);
		_tmp9_ = _tmp8_;
		if (VALA_IS_ARRAY_TYPE (_tmp9_)) {
			ValaArrayType* array_type = NULL;
			ValaDataType* _tmp10_;
			ValaDataType* _tmp11_;
			gboolean requires_constants_only = FALSE;
			ValaCodeNode* node = NULL;
			ValaCodeNode* _tmp12_;
			ValaCodeNode* _tmp13_;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			ValaCodeNode* _tmp21_;
			ValaCodeNode* _tmp22_;
			ValaDataType* inner_target_type = NULL;
			ValaArrayType* _tmp62_;
			gint _tmp63_;
			gint _tmp64_;
			_tmp10_ = vala_expression_get_target_type ((ValaExpression*) self);
			_tmp11_ = _tmp10_;
			array_type = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, VALA_TYPE_ARRAY_TYPE, ValaArrayType);
			requires_constants_only = FALSE;
			_tmp12_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
			_tmp13_ = _tmp12_;
			node = _tmp13_;
			while (TRUE) {
				ValaCodeNode* _tmp14_;
				ValaCodeNode* _tmp15_;
				ValaCodeNode* _tmp16_;
				ValaCodeNode* _tmp17_;
				ValaCodeNode* _tmp18_;
				_tmp14_ = node;
				if (!(_tmp14_ != NULL)) {
					break;
				}
				_tmp15_ = node;
				if (VALA_IS_CONSTANT (_tmp15_)) {
					requires_constants_only = TRUE;
					break;
				}
				_tmp16_ = node;
				_tmp17_ = vala_code_node_get_parent_node (_tmp16_);
				_tmp18_ = _tmp17_;
				node = _tmp18_;
			}
			_tmp21_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
			_tmp22_ = _tmp21_;
			if (!VALA_IS_ARRAY_CREATION_EXPRESSION (_tmp22_)) {
				_tmp20_ = !requires_constants_only;
			} else {
				_tmp20_ = FALSE;
			}
			if (_tmp20_) {
				gboolean _tmp23_ = FALSE;
				ValaCodeNode* _tmp24_;
				ValaCodeNode* _tmp25_;
				_tmp24_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
				_tmp25_ = _tmp24_;
				if (!VALA_IS_INITIALIZER_LIST (_tmp25_)) {
					_tmp23_ = TRUE;
				} else {
					ValaCodeNode* _tmp26_;
					ValaCodeNode* _tmp27_;
					ValaDataType* _tmp28_;
					ValaDataType* _tmp29_;
					ValaTypeSymbol* _tmp30_;
					ValaTypeSymbol* _tmp31_;
					_tmp26_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
					_tmp27_ = _tmp26_;
					_tmp28_ = vala_expression_get_target_type ((ValaExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, VALA_TYPE_INITIALIZER_LIST, ValaInitializerList));
					_tmp29_ = _tmp28_;
					_tmp30_ = vala_data_type_get_type_symbol (_tmp29_);
					_tmp31_ = _tmp30_;
					_tmp23_ = VALA_IS_STRUCT (_tmp31_);
				}
				_tmp19_ = _tmp23_;
			} else {
				_tmp19_ = FALSE;
			}
			if (_tmp19_) {
				ValaCodeNode* old_parent_node = NULL;
				ValaCodeNode* _tmp32_;
				ValaCodeNode* _tmp33_;
				ValaCodeNode* _tmp34_;
				ValaArrayCreationExpression* array_creation = NULL;
				ValaArrayType* _tmp35_;
				ValaDataType* _tmp36_;
				ValaDataType* _tmp37_;
				ValaDataType* _tmp38_;
				ValaDataType* _tmp39_;
				ValaArrayType* _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				ValaSourceReference* _tmp43_;
				ValaSourceReference* _tmp44_;
				ValaArrayCreationExpression* _tmp45_;
				ValaArrayCreationExpression* _tmp46_;
				ValaArrayCreationExpression* _tmp47_;
				ValaArrayType* _tmp48_;
				ValaDataType* _tmp49_;
				ValaDataType* _tmp50_;
				ValaDataType* _tmp51_;
				ValaDataType* _tmp52_;
				ValaArrayCreationExpression* _tmp53_;
				ValaDataType* _tmp54_;
				ValaDataType* _tmp55_;
				ValaArrayCreationExpression* _tmp56_;
				ValaDataType* _tmp57_;
				ValaDataType* _tmp58_;
				ValaCodeNode* _tmp59_;
				ValaArrayCreationExpression* _tmp60_;
				ValaArrayCreationExpression* _tmp61_;
				_tmp32_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
				_tmp33_ = _tmp32_;
				_tmp34_ = _vala_code_node_ref0 (_tmp33_);
				old_parent_node = _tmp34_;
				_tmp35_ = array_type;
				_tmp36_ = vala_array_type_get_element_type (_tmp35_);
				_tmp37_ = _tmp36_;
				_tmp38_ = vala_data_type_copy (_tmp37_);
				_tmp39_ = _tmp38_;
				_tmp40_ = array_type;
				_tmp41_ = vala_array_type_get_rank (_tmp40_);
				_tmp42_ = _tmp41_;
				_tmp43_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp44_ = _tmp43_;
				_tmp45_ = vala_array_creation_expression_new (_tmp39_, _tmp42_, self, _tmp44_);
				_tmp46_ = _tmp45_;
				_vala_code_node_unref0 (_tmp39_);
				array_creation = _tmp46_;
				_tmp47_ = array_creation;
				_tmp48_ = array_type;
				_tmp49_ = vala_array_type_get_length_type (_tmp48_);
				_tmp50_ = _tmp49_;
				_tmp51_ = vala_data_type_copy (_tmp50_);
				_tmp52_ = _tmp51_;
				vala_array_creation_expression_set_length_type (_tmp47_, _tmp52_);
				_vala_code_node_unref0 (_tmp52_);
				_tmp53_ = array_creation;
				_tmp54_ = vala_expression_get_target_type ((ValaExpression*) self);
				_tmp55_ = _tmp54_;
				vala_expression_set_target_type ((ValaExpression*) _tmp53_, _tmp55_);
				_tmp56_ = array_creation;
				_tmp57_ = vala_expression_get_formal_target_type ((ValaExpression*) self);
				_tmp58_ = _tmp57_;
				vala_expression_set_formal_target_type ((ValaExpression*) _tmp56_, _tmp58_);
				_tmp59_ = old_parent_node;
				_tmp60_ = array_creation;
				vala_code_node_replace_expression (_tmp59_, (ValaExpression*) self, (ValaExpression*) _tmp60_);
				vala_code_node_set_checked ((ValaCodeNode*) self, FALSE);
				_tmp61_ = array_creation;
				result = vala_code_node_check ((ValaCodeNode*) _tmp61_, context);
				_vala_code_node_unref0 (array_creation);
				_vala_code_node_unref0 (old_parent_node);
				return result;
			}
			_tmp62_ = array_type;
			_tmp63_ = vala_array_type_get_rank (_tmp62_);
			_tmp64_ = _tmp63_;
			if (_tmp64_ > 1) {
				ValaArrayType* inner_array_type = NULL;
				ValaArrayType* _tmp65_;
				ValaDataType* _tmp66_;
				ValaArrayType* _tmp67_;
				gint _tmp68_;
				gint _tmp69_;
				ValaArrayType* _tmp70_;
				ValaDataType* _tmp71_;
				_tmp65_ = array_type;
				_tmp66_ = vala_data_type_copy ((ValaDataType*) _tmp65_);
				inner_array_type = G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, VALA_TYPE_ARRAY_TYPE, ValaArrayType);
				_tmp67_ = inner_array_type;
				_tmp68_ = vala_array_type_get_rank (_tmp67_);
				_tmp69_ = _tmp68_;
				vala_array_type_set_rank (_tmp67_, _tmp69_ - 1);
				_tmp70_ = inner_array_type;
				_tmp71_ = _vala_code_node_ref0 ((ValaDataType*) _tmp70_);
				_vala_code_node_unref0 (inner_target_type);
				inner_target_type = _tmp71_;
				_vala_code_node_unref0 (inner_array_type);
			} else {
				ValaArrayType* _tmp72_;
				ValaDataType* _tmp73_;
				ValaDataType* _tmp74_;
				ValaDataType* _tmp75_;
				_tmp72_ = array_type;
				_tmp73_ = vala_array_type_get_element_type (_tmp72_);
				_tmp74_ = _tmp73_;
				_tmp75_ = vala_data_type_copy (_tmp74_);
				_vala_code_node_unref0 (inner_target_type);
				inner_target_type = _tmp75_;
			}
			{
				ValaList* _e_list = NULL;
				ValaList* _tmp76_;
				ValaList* _tmp77_;
				gint _e_size = 0;
				ValaList* _tmp78_;
				gint _tmp79_;
				gint _tmp80_;
				gint _e_index = 0;
				_tmp76_ = vala_initializer_list_get_initializers (self);
				_tmp77_ = _vala_iterable_ref0 (_tmp76_);
				_e_list = _tmp77_;
				_tmp78_ = _e_list;
				_tmp79_ = vala_collection_get_size ((ValaCollection*) _tmp78_);
				_tmp80_ = _tmp79_;
				_e_size = _tmp80_;
				_e_index = -1;
				while (TRUE) {
					ValaExpression* e = NULL;
					ValaList* _tmp81_;
					gpointer _tmp82_;
					ValaExpression* _tmp83_;
					ValaDataType* _tmp84_;
					_e_index = _e_index + 1;
					if (!(_e_index < _e_size)) {
						break;
					}
					_tmp81_ = _e_list;
					_tmp82_ = vala_list_get (_tmp81_, _e_index);
					e = (ValaExpression*) _tmp82_;
					_tmp83_ = e;
					_tmp84_ = inner_target_type;
					vala_expression_set_target_type (_tmp83_, _tmp84_);
					_vala_code_node_unref0 (e);
				}
				_vala_iterable_unref0 (_e_list);
			}
			_vala_code_node_unref0 (inner_target_type);
		} else {
			ValaDataType* _tmp85_;
			ValaDataType* _tmp86_;
			ValaTypeSymbol* _tmp87_;
			ValaTypeSymbol* _tmp88_;
			_tmp85_ = vala_expression_get_target_type ((ValaExpression*) self);
			_tmp86_ = _tmp85_;
			_tmp87_ = vala_data_type_get_type_symbol (_tmp86_);
			_tmp88_ = _tmp87_;
			if (VALA_IS_STRUCT (_tmp88_)) {
				ValaStruct* st = NULL;
				ValaDataType* _tmp89_;
				ValaDataType* _tmp90_;
				ValaTypeSymbol* _tmp91_;
				ValaTypeSymbol* _tmp92_;
				gboolean _tmp99_ = FALSE;
				ValaCodeNode* _tmp100_;
				ValaCodeNode* _tmp101_;
				gboolean in_array_creation_initializer = FALSE;
				ValaObjectCreationExpression* struct_creation = NULL;
				ValaIterator* field_it = NULL;
				ValaStruct* _tmp125_;
				ValaList* _tmp126_;
				ValaIterator* _tmp127_;
				_tmp89_ = vala_expression_get_target_type ((ValaExpression*) self);
				_tmp90_ = _tmp89_;
				_tmp91_ = vala_data_type_get_type_symbol (_tmp90_);
				_tmp92_ = _tmp91_;
				st = G_TYPE_CHECK_INSTANCE_CAST (_tmp92_, VALA_TYPE_STRUCT, ValaStruct);
				while (TRUE) {
					ValaStruct* _tmp93_;
					ValaStruct* _tmp94_;
					ValaStruct* _tmp95_;
					ValaStruct* _tmp96_;
					ValaStruct* _tmp97_;
					ValaStruct* _tmp98_;
					_tmp93_ = st;
					_tmp94_ = vala_struct_get_base_struct (_tmp93_);
					_tmp95_ = _tmp94_;
					if (!(_tmp95_ != NULL)) {
						break;
					}
					_tmp96_ = st;
					_tmp97_ = vala_struct_get_base_struct (_tmp96_);
					_tmp98_ = _tmp97_;
					st = _tmp98_;
				}
				_tmp100_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
				_tmp101_ = _tmp100_;
				if (VALA_IS_INITIALIZER_LIST (_tmp101_)) {
					ValaCodeNode* _tmp102_;
					ValaCodeNode* _tmp103_;
					ValaCodeNode* _tmp104_;
					ValaCodeNode* _tmp105_;
					_tmp102_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
					_tmp103_ = _tmp102_;
					_tmp104_ = vala_code_node_get_parent_node (_tmp103_);
					_tmp105_ = _tmp104_;
					_tmp99_ = VALA_IS_ARRAY_CREATION_EXPRESSION (_tmp105_);
				} else {
					_tmp99_ = FALSE;
				}
				in_array_creation_initializer = _tmp99_;
				struct_creation = NULL;
				if (in_array_creation_initializer) {
					ValaMemberAccess* ma = NULL;
					ValaStruct* _tmp106_;
					const gchar* _tmp107_;
					const gchar* _tmp108_;
					ValaSourceReference* _tmp109_;
					ValaSourceReference* _tmp110_;
					ValaMemberAccess* _tmp111_;
					ValaMemberAccess* _tmp112_;
					ValaMemberAccess* _tmp113_;
					ValaStruct* _tmp114_;
					ValaMemberAccess* _tmp115_;
					ValaSourceReference* _tmp116_;
					ValaSourceReference* _tmp117_;
					ValaObjectCreationExpression* _tmp118_;
					ValaObjectCreationExpression* _tmp119_;
					ValaDataType* _tmp120_;
					ValaDataType* _tmp121_;
					ValaDataType* _tmp122_;
					ValaDataType* _tmp123_;
					ValaObjectCreationExpression* _tmp124_;
					_tmp106_ = st;
					_tmp107_ = vala_symbol_get_name ((ValaSymbol*) _tmp106_);
					_tmp108_ = _tmp107_;
					_tmp109_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp110_ = _tmp109_;
					_tmp111_ = vala_member_access_new_simple (_tmp108_, _tmp110_);
					ma = _tmp111_;
					_tmp112_ = ma;
					vala_member_access_set_creation_member (_tmp112_, TRUE);
					_tmp113_ = ma;
					_tmp114_ = st;
					vala_expression_set_symbol_reference ((ValaExpression*) _tmp113_, (ValaSymbol*) _tmp114_);
					_tmp115_ = ma;
					_tmp116_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp117_ = _tmp116_;
					_tmp118_ = vala_object_creation_expression_new (_tmp115_, _tmp117_);
					_vala_code_node_unref0 (struct_creation);
					struct_creation = _tmp118_;
					_tmp119_ = struct_creation;
					_tmp120_ = vala_expression_get_target_type ((ValaExpression*) self);
					_tmp121_ = _tmp120_;
					_tmp122_ = vala_data_type_copy (_tmp121_);
					_tmp123_ = _tmp122_;
					vala_expression_set_target_type ((ValaExpression*) _tmp119_, _tmp123_);
					_vala_code_node_unref0 (_tmp123_);
					_tmp124_ = struct_creation;
					vala_object_creation_expression_set_struct_creation (_tmp124_, TRUE);
					_vala_code_node_unref0 (ma);
				}
				_tmp125_ = st;
				_tmp126_ = vala_struct_get_fields (_tmp125_);
				_tmp127_ = vala_iterable_iterator ((ValaIterable*) _tmp126_);
				field_it = _tmp127_;
				{
					ValaList* _e_list = NULL;
					ValaList* _tmp128_;
					ValaList* _tmp129_;
					gint _e_size = 0;
					ValaList* _tmp130_;
					gint _tmp131_;
					gint _tmp132_;
					gint _e_index = 0;
					_tmp128_ = vala_initializer_list_get_initializers (self);
					_tmp129_ = _vala_iterable_ref0 (_tmp128_);
					_e_list = _tmp129_;
					_tmp130_ = _e_list;
					_tmp131_ = vala_collection_get_size ((ValaCollection*) _tmp130_);
					_tmp132_ = _tmp131_;
					_e_size = _tmp132_;
					_e_index = -1;
					while (TRUE) {
						ValaExpression* e = NULL;
						ValaList* _tmp133_;
						gpointer _tmp134_;
						ValaField* field = NULL;
						_e_index = _e_index + 1;
						if (!(_e_index < _e_size)) {
							break;
						}
						_tmp133_ = _e_list;
						_tmp134_ = vala_list_get (_tmp133_, _e_index);
						e = (ValaExpression*) _tmp134_;
						field = NULL;
						while (TRUE) {
							ValaField* _tmp135_;
							ValaIterator* _tmp136_;
							ValaIterator* _tmp146_;
							gpointer _tmp147_;
							ValaField* _tmp148_;
							ValaMemberBinding _tmp149_;
							ValaMemberBinding _tmp150_;
							_tmp135_ = field;
							if (!(_tmp135_ == NULL)) {
								break;
							}
							_tmp136_ = field_it;
							if (!vala_iterator_next (_tmp136_)) {
								ValaExpression* _tmp137_;
								ValaSourceReference* _tmp138_;
								ValaSourceReference* _tmp139_;
								ValaDataType* _tmp140_;
								ValaDataType* _tmp141_;
								gchar* _tmp142_;
								gchar* _tmp143_;
								gchar* _tmp144_;
								gchar* _tmp145_;
								vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
								_tmp137_ = e;
								_tmp138_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp137_);
								_tmp139_ = _tmp138_;
								_tmp140_ = vala_expression_get_target_type ((ValaExpression*) self);
								_tmp141_ = _tmp140_;
								_tmp142_ = vala_code_node_to_string ((ValaCodeNode*) _tmp141_);
								_tmp143_ = _tmp142_;
								_tmp144_ = g_strdup_printf ("too many expressions in initializer list for `%s'", _tmp143_);
								_tmp145_ = _tmp144_;
								vala_report_error (_tmp139_, _tmp145_);
								_g_free0 (_tmp145_);
								_g_free0 (_tmp143_);
								result = FALSE;
								_vala_code_node_unref0 (field);
								_vala_code_node_unref0 (e);
								_vala_iterable_unref0 (_e_list);
								_vala_iterator_unref0 (field_it);
								_vala_code_node_unref0 (struct_creation);
								return result;
							}
							_tmp146_ = field_it;
							_tmp147_ = vala_iterator_get (_tmp146_);
							_vala_code_node_unref0 (field);
							field = (ValaField*) _tmp147_;
							_tmp148_ = field;
							_tmp149_ = vala_field_get_binding (_tmp148_);
							_tmp150_ = _tmp149_;
							if (_tmp150_ != VALA_MEMBER_BINDING_INSTANCE) {
								_vala_code_node_unref0 (field);
								field = NULL;
							}
						}
						if (in_array_creation_initializer) {
							ValaMemberInitializer* member_init = NULL;
							ValaField* _tmp151_;
							const gchar* _tmp152_;
							const gchar* _tmp153_;
							ValaExpression* _tmp154_;
							ValaExpression* _tmp155_;
							ValaSourceReference* _tmp156_;
							ValaSourceReference* _tmp157_;
							ValaMemberInitializer* _tmp158_;
							ValaObjectCreationExpression* _tmp159_;
							ValaMemberInitializer* _tmp160_;
							_tmp151_ = field;
							_tmp152_ = vala_symbol_get_name ((ValaSymbol*) _tmp151_);
							_tmp153_ = _tmp152_;
							_tmp154_ = e;
							_tmp155_ = e;
							_tmp156_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp155_);
							_tmp157_ = _tmp156_;
							_tmp158_ = vala_member_initializer_new (_tmp153_, _tmp154_, _tmp157_);
							member_init = _tmp158_;
							_tmp159_ = struct_creation;
							_tmp160_ = member_init;
							vala_object_creation_expression_add_member_initializer (_tmp159_, _tmp160_);
							_vala_code_node_unref0 (member_init);
						} else {
							ValaExpression* _tmp161_;
							ValaField* _tmp162_;
							ValaDataType* _tmp163_;
							ValaDataType* _tmp164_;
							ValaDataType* _tmp165_;
							ValaDataType* _tmp166_;
							ValaDataType* _tmp167_;
							ValaDataType* _tmp168_;
							gboolean _tmp169_;
							gboolean _tmp170_;
							_tmp161_ = e;
							_tmp162_ = field;
							_tmp163_ = vala_variable_get_variable_type ((ValaVariable*) _tmp162_);
							_tmp164_ = _tmp163_;
							_tmp165_ = vala_data_type_copy (_tmp164_);
							_tmp166_ = _tmp165_;
							vala_expression_set_target_type (_tmp161_, _tmp166_);
							_vala_code_node_unref0 (_tmp166_);
							_tmp167_ = vala_expression_get_target_type ((ValaExpression*) self);
							_tmp168_ = _tmp167_;
							_tmp169_ = vala_data_type_get_value_owned (_tmp168_);
							_tmp170_ = _tmp169_;
							if (!_tmp170_) {
								ValaExpression* _tmp171_;
								ValaDataType* _tmp172_;
								ValaDataType* _tmp173_;
								_tmp171_ = e;
								_tmp172_ = vala_expression_get_target_type (_tmp171_);
								_tmp173_ = _tmp172_;
								vala_data_type_set_value_owned (_tmp173_, FALSE);
							}
						}
						_vala_code_node_unref0 (field);
						_vala_code_node_unref0 (e);
					}
					_vala_iterable_unref0 (_e_list);
				}
				if (in_array_creation_initializer) {
					ValaCodeNode* _tmp174_;
					ValaCodeNode* _tmp175_;
					ValaObjectCreationExpression* _tmp176_;
					ValaObjectCreationExpression* _tmp177_;
					_tmp174_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
					_tmp175_ = _tmp174_;
					_tmp176_ = struct_creation;
					vala_code_node_replace_expression (_tmp175_, (ValaExpression*) self, (ValaExpression*) _tmp176_);
					vala_code_node_set_checked ((ValaCodeNode*) self, FALSE);
					_tmp177_ = struct_creation;
					result = vala_code_node_check ((ValaCodeNode*) _tmp177_, context);
					_vala_iterator_unref0 (field_it);
					_vala_code_node_unref0 (struct_creation);
					return result;
				}
				_vala_iterator_unref0 (field_it);
				_vala_code_node_unref0 (struct_creation);
			} else {
				ValaSourceReference* _tmp178_;
				ValaSourceReference* _tmp179_;
				ValaDataType* _tmp180_;
				ValaDataType* _tmp181_;
				gchar* _tmp182_;
				gchar* _tmp183_;
				gchar* _tmp184_;
				gchar* _tmp185_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp178_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp179_ = _tmp178_;
				_tmp180_ = vala_expression_get_target_type ((ValaExpression*) self);
				_tmp181_ = _tmp180_;
				_tmp182_ = vala_code_node_to_string ((ValaCodeNode*) _tmp181_);
				_tmp183_ = _tmp182_;
				_tmp184_ = g_strdup_printf ("initializer list used for `%s', which is neither array nor struct", _tmp183_);
				_tmp185_ = _tmp184_;
				vala_report_error (_tmp179_, _tmp185_);
				_g_free0 (_tmp185_);
				_g_free0 (_tmp183_);
				result = FALSE;
				return result;
			}
		}
	}
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp186_;
		ValaList* _tmp187_;
		gint _expr_size = 0;
		ValaList* _tmp188_;
		gint _tmp189_;
		gint _tmp190_;
		gint _expr_index = 0;
		_tmp186_ = self->priv->initializers;
		_tmp187_ = _vala_iterable_ref0 (_tmp186_);
		_expr_list = _tmp187_;
		_tmp188_ = _expr_list;
		_tmp189_ = vala_collection_get_size ((ValaCollection*) _tmp188_);
		_tmp190_ = _tmp189_;
		_expr_size = _tmp190_;
		_expr_index = -1;
		while (TRUE) {
			ValaExpression* expr = NULL;
			ValaList* _tmp191_;
			gpointer _tmp192_;
			ValaExpression* _tmp193_;
			_expr_index = _expr_index + 1;
			if (!(_expr_index < _expr_size)) {
				break;
			}
			_tmp191_ = _expr_list;
			_tmp192_ = vala_list_get (_tmp191_, _expr_index);
			expr = (ValaExpression*) _tmp192_;
			_tmp193_ = expr;
			vala_code_node_check ((ValaCodeNode*) _tmp193_, context);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
	_error_ = FALSE;
	{
		ValaList* _e_list = NULL;
		ValaList* _tmp194_;
		ValaList* _tmp195_;
		gint _e_size = 0;
		ValaList* _tmp196_;
		gint _tmp197_;
		gint _tmp198_;
		gint _e_index = 0;
		_tmp194_ = vala_initializer_list_get_initializers (self);
		_tmp195_ = _vala_iterable_ref0 (_tmp194_);
		_e_list = _tmp195_;
		_tmp196_ = _e_list;
		_tmp197_ = vala_collection_get_size ((ValaCollection*) _tmp196_);
		_tmp198_ = _tmp197_;
		_e_size = _tmp198_;
		_e_index = -1;
		while (TRUE) {
			ValaExpression* e = NULL;
			ValaList* _tmp199_;
			gpointer _tmp200_;
			ValaExpression* _tmp201_;
			ValaDataType* _tmp202_;
			ValaDataType* _tmp203_;
			ValaUnaryExpression* unary = NULL;
			ValaExpression* _tmp207_;
			gboolean _tmp208_ = FALSE;
			ValaUnaryExpression* _tmp209_;
			_e_index = _e_index + 1;
			if (!(_e_index < _e_size)) {
				break;
			}
			_tmp199_ = _e_list;
			_tmp200_ = vala_list_get (_tmp199_, _e_index);
			e = (ValaExpression*) _tmp200_;
			_tmp201_ = e;
			_tmp202_ = vala_expression_get_value_type (_tmp201_);
			_tmp203_ = _tmp202_;
			if (_tmp203_ == NULL) {
				ValaExpression* _tmp204_;
				ValaSourceReference* _tmp205_;
				ValaSourceReference* _tmp206_;
				_error_ = TRUE;
				_tmp204_ = e;
				_tmp205_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp204_);
				_tmp206_ = _tmp205_;
				vala_report_error (_tmp206_, "expression type not allowed as initializer");
				_vala_code_node_unref0 (e);
				continue;
			}
			_tmp207_ = e;
			unary = VALA_IS_UNARY_EXPRESSION (_tmp207_) ? ((ValaUnaryExpression*) _tmp207_) : NULL;
			_tmp209_ = unary;
			if (_tmp209_ != NULL) {
				gboolean _tmp210_ = FALSE;
				ValaUnaryExpression* _tmp211_;
				ValaUnaryOperator _tmp212_;
				ValaUnaryOperator _tmp213_;
				_tmp211_ = unary;
				_tmp212_ = vala_unary_expression_get_operator (_tmp211_);
				_tmp213_ = _tmp212_;
				if (_tmp213_ == VALA_UNARY_OPERATOR_REF) {
					_tmp210_ = TRUE;
				} else {
					ValaUnaryExpression* _tmp214_;
					ValaUnaryOperator _tmp215_;
					ValaUnaryOperator _tmp216_;
					_tmp214_ = unary;
					_tmp215_ = vala_unary_expression_get_operator (_tmp214_);
					_tmp216_ = _tmp215_;
					_tmp210_ = _tmp216_ == VALA_UNARY_OPERATOR_OUT;
				}
				_tmp208_ = _tmp210_;
			} else {
				_tmp208_ = FALSE;
			}
			if (_tmp208_) {
			} else {
				ValaExpression* _tmp217_;
				ValaDataType* _tmp218_;
				ValaDataType* _tmp219_;
				ValaExpression* _tmp220_;
				ValaDataType* _tmp221_;
				ValaDataType* _tmp222_;
				_tmp217_ = e;
				_tmp218_ = vala_expression_get_value_type (_tmp217_);
				_tmp219_ = _tmp218_;
				_tmp220_ = e;
				_tmp221_ = vala_expression_get_target_type (_tmp220_);
				_tmp222_ = _tmp221_;
				if (!vala_data_type_compatible (_tmp219_, _tmp222_)) {
					ValaExpression* _tmp223_;
					ValaExpression* _tmp224_;
					ValaSourceReference* _tmp225_;
					ValaSourceReference* _tmp226_;
					ValaExpression* _tmp227_;
					ValaDataType* _tmp228_;
					ValaDataType* _tmp229_;
					gchar* _tmp230_;
					gchar* _tmp231_;
					ValaExpression* _tmp232_;
					ValaDataType* _tmp233_;
					ValaDataType* _tmp234_;
					gchar* _tmp235_;
					gchar* _tmp236_;
					gchar* _tmp237_;
					gchar* _tmp238_;
					_error_ = TRUE;
					_tmp223_ = e;
					vala_code_node_set_error ((ValaCodeNode*) _tmp223_, TRUE);
					_tmp224_ = e;
					_tmp225_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp224_);
					_tmp226_ = _tmp225_;
					_tmp227_ = e;
					_tmp228_ = vala_expression_get_target_type (_tmp227_);
					_tmp229_ = _tmp228_;
					_tmp230_ = vala_code_node_to_string ((ValaCodeNode*) _tmp229_);
					_tmp231_ = _tmp230_;
					_tmp232_ = e;
					_tmp233_ = vala_expression_get_value_type (_tmp232_);
					_tmp234_ = _tmp233_;
					_tmp235_ = vala_code_node_to_string ((ValaCodeNode*) _tmp234_);
					_tmp236_ = _tmp235_;
					_tmp237_ = g_strdup_printf ("Expected initializer of type `%s' but got `%s'", _tmp231_, _tmp236_);
					_tmp238_ = _tmp237_;
					vala_report_error (_tmp226_, _tmp238_);
					_g_free0 (_tmp238_);
					_g_free0 (_tmp236_);
					_g_free0 (_tmp231_);
				}
			}
			_vala_code_node_unref0 (e);
		}
		_vala_iterable_unref0 (_e_list);
	}
	if (!_error_) {
		ValaDataType* _tmp239_;
		ValaDataType* _tmp240_;
		ValaDataType* _tmp241_;
		ValaDataType* _tmp242_;
		ValaDataType* _tmp243_;
		ValaDataType* _tmp244_;
		_tmp239_ = vala_expression_get_target_type ((ValaExpression*) self);
		_tmp240_ = _tmp239_;
		_tmp241_ = vala_data_type_copy (_tmp240_);
		_tmp242_ = _tmp241_;
		vala_expression_set_value_type ((ValaExpression*) self, _tmp242_);
		_vala_code_node_unref0 (_tmp242_);
		_tmp243_ = vala_expression_get_value_type ((ValaExpression*) self);
		_tmp244_ = _tmp243_;
		vala_data_type_set_nullable (_tmp244_, FALSE);
	}
	_tmp245_ = vala_expression_get_value_type ((ValaExpression*) self);
	_tmp246_ = _tmp245_;
	if (_tmp246_ != NULL) {
		ValaDataType* _tmp247_;
		ValaDataType* _tmp248_;
		_tmp247_ = vala_expression_get_value_type ((ValaExpression*) self);
		_tmp248_ = _tmp247_;
		vala_code_node_check ((ValaCodeNode*) _tmp248_, context);
	}
	result = !_error_;
	return result;
}

static void
vala_initializer_list_real_emit (ValaCodeNode* base,
                                 ValaCodeGenerator* codegen)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (codegen != NULL);
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _expr_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _expr_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_expr_list = _tmp1_;
		_tmp2_ = _expr_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_expr_size = _tmp4_;
		_expr_index = -1;
		while (TRUE) {
			ValaExpression* expr = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_expr_index = _expr_index + 1;
			if (!(_expr_index < _expr_size)) {
				break;
			}
			_tmp5_ = _expr_list;
			_tmp6_ = vala_list_get (_tmp5_, _expr_index);
			expr = (ValaExpression*) _tmp6_;
			_tmp7_ = expr;
			vala_code_node_emit ((ValaCodeNode*) _tmp7_, codegen);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
	vala_code_visitor_visit_initializer_list ((ValaCodeVisitor*) codegen, self);
	vala_code_visitor_visit_expression ((ValaCodeVisitor*) codegen, (ValaExpression*) self);
}

static void
vala_initializer_list_real_get_used_variables (ValaCodeNode* base,
                                               ValaCollection* collection)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (collection != NULL);
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _expr_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _expr_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_expr_list = _tmp1_;
		_tmp2_ = _expr_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_expr_size = _tmp4_;
		_expr_index = -1;
		while (TRUE) {
			ValaExpression* expr = NULL;
			ValaList* _tmp5_;
			gpointer _tmp6_;
			ValaExpression* _tmp7_;
			_expr_index = _expr_index + 1;
			if (!(_expr_index < _expr_size)) {
				break;
			}
			_tmp5_ = _expr_list;
			_tmp6_ = vala_list_get (_tmp5_, _expr_index);
			expr = (ValaExpression*) _tmp6_;
			_tmp7_ = expr;
			vala_code_node_get_used_variables ((ValaCodeNode*) _tmp7_, collection);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
}

static void
vala_initializer_list_class_init (ValaInitializerListClass * klass,
                                  gpointer klass_data)
{
	vala_initializer_list_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_initializer_list_finalize;
	g_type_class_adjust_private_offset (klass, &ValaInitializerList_private_offset);
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_initializer_list_real_accept_children;
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_initializer_list_real_accept;
	((ValaExpressionClass *) klass)->is_constant = (gboolean (*) (ValaExpression*)) vala_initializer_list_real_is_constant;
	((ValaExpressionClass *) klass)->is_pure = (gboolean (*) (ValaExpression*)) vala_initializer_list_real_is_pure;
	((ValaExpressionClass *) klass)->is_accessible = (gboolean (*) (ValaExpression*, ValaSymbol*)) vala_initializer_list_real_is_accessible;
	((ValaCodeNodeClass *) klass)->to_string = (gchar* (*) (ValaCodeNode*)) vala_initializer_list_real_to_string;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode*, ValaExpression*, ValaExpression*)) vala_initializer_list_real_replace_expression;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_initializer_list_real_check;
	((ValaCodeNodeClass *) klass)->emit = (void (*) (ValaCodeNode*, ValaCodeGenerator*)) vala_initializer_list_real_emit;
	((ValaCodeNodeClass *) klass)->get_used_variables = (void (*) (ValaCodeNode*, ValaCollection*)) vala_initializer_list_real_get_used_variables;
}

static void
vala_initializer_list_instance_init (ValaInitializerList * self,
                                     gpointer klass)
{
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	self->priv = vala_initializer_list_get_instance_private (self);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	self->priv->initializers = (ValaList*) _tmp1_;
}

static void
vala_initializer_list_finalize (ValaCodeNode * obj)
{
	ValaInitializerList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_INITIALIZER_LIST, ValaInitializerList);
	_vala_iterable_unref0 (self->priv->initializers);
	VALA_CODE_NODE_CLASS (vala_initializer_list_parent_class)->finalize (obj);
}

/**
 * Represents an array or struct initializer list in the source code.
 */
static GType
vala_initializer_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaInitializerListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_initializer_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaInitializerList), 0, (GInstanceInitFunc) vala_initializer_list_instance_init, NULL };
	GType vala_initializer_list_type_id;
	vala_initializer_list_type_id = g_type_register_static (VALA_TYPE_EXPRESSION, "ValaInitializerList", &g_define_type_info, 0);
	ValaInitializerList_private_offset = g_type_add_instance_private (vala_initializer_list_type_id, sizeof (ValaInitializerListPrivate));
	return vala_initializer_list_type_id;
}

GType
vala_initializer_list_get_type (void)
{
	static volatile gsize vala_initializer_list_type_id__volatile = 0;
	if (g_once_init_enter (&vala_initializer_list_type_id__volatile)) {
		GType vala_initializer_list_type_id;
		vala_initializer_list_type_id = vala_initializer_list_get_type_once ();
		g_once_init_leave (&vala_initializer_list_type_id__volatile, vala_initializer_list_type_id);
	}
	return vala_initializer_list_type_id__volatile;
}

